<template>
  <div class="page">
    <el-form size="small" :inline="true" class="query-form" ref="searchForm" :model="searchForm" @keyup.enter.native="refreshList()" @submit.native.prevent>
      <!-- 搜索框-->
      <el-form-item prop="name">
        <el-input size="small" v-model="searchForm.name" placeholder="职位名称" clearable></el-input>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" @click="refreshList()" size="small" icon="el-icon-search">查询</el-button>
        <el-button @click="resetSearch()" size="small" icon="el-icon-refresh-right">重置</el-button>
      </el-form-item>

    </el-form>

    <div class="bg-white top" style="">
      <vxe-toolbar :refresh="{query: refreshList}" import export custom>
        <template #buttons>
          <el-button v-if="hasPermission('job:job_position:add')" type="primary" size="small" icon="el-icon-plus" @click="add()">新建</el-button>
          <el-button v-if="hasPermission('job:job_position:del')" type="danger"   size="small" icon="el-icon-delete" @click="del()" :disabled="$refs.jobPositionTable && $refs.jobPositionTable.getCheckboxRecords().length === 0" plain>删除</el-button>
          <el-button v-if="hasPermission('job:job_position:add','job:job_position:edit','job:job_position:del')" type="primary"   size="small" icon="el-icon-check" @click="change(null,'1')" :disabled="$refs.jobPositionTable && $refs.jobPositionTable.getCheckboxRecords().length === 0" plain>启用</el-button>
          <el-button v-if="hasPermission('job:job_position:add','job:job_position:edit','job:job_position:del')" type="primary"   size="small" icon="el-icon-close" @click="change(null,'2')" :disabled="$refs.jobPositionTable && $refs.jobPositionTable.getCheckboxRecords().length === 0" plain>停用</el-button>
          <el-button type="default" size="small"  @click="goLog()"  plain>变更日志</el-button>
          <el-button style="margin-right: 50px" v-if="hasPermission('job:job_position:import')"  type="default" @click="downloadTpl()" size="small">下载模板</el-button>
          <el-switch
            @change="switchChange"
            v-model="switchBlock"
            active-text="展示停用职位"
            inactive-text="不展示停用职位">
          </el-switch>
        </template>
      </vxe-toolbar>
      <div style="height: calc(100% - 80px)">
        <vxe-table
          border="inner"
          auto-resize
          resizable
          height="auto"
          :loading="loading"
          size="small"
          ref="jobPositionTable"
          show-header-overflow
          show-overflow
          highlight-hover-row
          :menu-config="{}"
          :export-config="{
                    remote: true,
                    filename: `职位数据${moment(new Date()).format('YYYY-MM-DD')}`,
                    sheetName: '职位数据',
                    exportMethod: exportMethod,
                    types: ['xlsx'],
                    modes: ['current', 'all']
                  }"
          :import-config="{
                    importMethod: importMethod,
                    types: ['xls', 'xlsx'],
                    remote: true}"
          @sort-change="sortChangeHandle"
          :sort-config="{remote:true}"
          :data="dataList"
          :checkbox-config="{}">
          <vxe-column type="seq" width="60" title="序号"></vxe-column>
          <vxe-column type="checkbox" width="40" ></vxe-column>
          <vxe-column  title="职位名称" field="name">
            <template slot-scope="scope">
              <el-link  type="primary" :underline="false" v-if="hasPermission('sys:project:view','sys:project:edit','sys:project:add')" @click="view(scope.row.id)">{{scope.row.name}}</el-link>
              <span v-else>{{scope.row.name}}</span>
            </template>
          </vxe-column>
          <vxe-column width="150" title="职位编码" field="no"></vxe-column>
          <vxe-column width="180" title="所属部门" field="officeId"></vxe-column>
          <vxe-column width="150" title="对应职务" field="positionId"></vxe-column>
          <vxe-column width="130" title="编制人数" field="staffNum"></vxe-column>
          <vxe-column width="130" title="状态" field="useFlag">
            <template slot-scope="scope">
              {{ $dictUtils.getDictLabel("use_flag", scope.row.useFlag, '-') }}
            </template>
          </vxe-column>
          <vxe-column title="操作" width="180" fixed="right" align="center">
            <template  slot-scope="scope">
              <el-button v-if="hasPermission('job:job_position:view')" type="text" icon="el-icon-view" size="small" @click="view(scope.row.id)">查看</el-button>
              <el-button v-if="hasPermission('job:job_position:edit')" type="text" icon="el-icon-edit" size="small" @click="edit(scope.row.id)">修改</el-button>
              <el-button v-if="hasPermission('job:job_position:del')" type="text"  icon="el-icon-delete" size="small" @click="del(scope.row.id)">删除</el-button>
            </template>
          </vxe-column>
        </vxe-table>
        <vxe-pager
          background
          size="small"
          :current-page="tablePage.currentPage"
          :page-size="tablePage.pageSize"
          :total="tablePage.total"
          :page-sizes="[10, 20, 100, 1000, {label: '全量数据', value: 1000000}]"
          :layouts="['PrevPage', 'JumpNumber', 'NextPage', 'FullJump', 'Sizes', 'Total']"
          @page-change="currentChangeHandle">
        </vxe-pager>
      </div>
    </div>
    <JobPositionForm  ref="jobPositionForm" @refreshDataList="refreshList"></JobPositionForm>
  </div>
</template>

<script>
  import JobPositionForm from './JobPositionForm'
  import JobPositionService from '@/api/position/JobPositionService'
  export default {
    props: {
      index: {
        type: String,
        default: ''
      },
      i: {
        type: String,
        default: ''
      }
    },
    data () {
      return {
        switchBlock: true,
        searchForm: {
        },
        dataList: [],
        tablePage: {
          total: 0,
          currentPage: 1,
          pageSize: 10,
          orders: []
        },
        loading: false
      }
    },
    jobPositionService: null,
    created () {
      this.jobPositionService = new JobPositionService()
    },
    watch: {
      index (index) {
        if (index === this.i) {
          this.refreshList()
        }
      }
    },
    components: {
      JobPositionForm
    },
    mounted () {
      this.refreshList()
    },

    methods: {
      goLog () {
        this.$router.push({path: `/position/PositionLog`, query: {type: '3'}})
      },
      // 新增
      add () {
        this.$refs.jobPositionForm.init('add', '')
      },
      // 修改
      edit (id) {
        id = id || this.$refs.jobPositionTable.getCheckboxRecords().map(item => {
          return item.id
        })[0]
        this.$refs.jobPositionForm.init('edit', id)
      },
      // 查看
      view (id) {
        this.$refs.jobPositionForm.init('view', id)
      },
      change (id, useFlag) {
        let ids = id || this.$refs.jobPositionTable.getCheckboxRecords().map(item => {
          return item.id
        }).join(',')
        this.$confirm(`确定改变所选数据的状态吗?`, '提示', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        }).then(() => {
          this.loading = true
          this.jobPositionService.changeUseFlag(ids, useFlag).then(({data}) => {
            this.$message.success(data)
            this.refreshList()
            this.loading = false
          })
        })
      },
      // 获取数据列表
      refreshList () {
        this.loading = true
        this.jobPositionService.list({
          'current': this.tablePage.currentPage,
          'size': this.tablePage.pageSize,
          'orders': this.tablePage.orders,
          ...this.searchForm
        }).then(({data}) => {
          this.dataList = data.records
          this.tablePage.total = data.total
          this.loading = false
        })
      },
      // 当前页
      currentChangeHandle ({ currentPage, pageSize }) {
        this.tablePage.currentPage = currentPage
        this.tablePage.pageSize = pageSize
        this.refreshList()
      },
      // 排序
      sortChangeHandle (column) {
        this.tablePage.orders = []
        if (column.order != null) {
          this.tablePage.orders.push({column: this.$utils.toLine(column.property), asc: column.order === 'asc'})
        }
        this.refreshList()
      },
      // 删除
      del (id) {
        let ids = id || this.$refs.jobPositionTable.getCheckboxRecords().map(item => {
          return item.id
        }).join(',')
        this.$confirm(`确定删除所选项吗?`, '提示', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        }).then(() => {
          this.loading = true
          this.jobPositionService.delete(ids).then(({data}) => {
            this.$message.success(data)
            this.refreshList()
            this.loading = false
          })
        })
      },
      resetSearch () {
        this.$refs.searchForm.resetFields()
        this.refreshList()
      },
      switchChange () {
        if (this.switchBlock === false) {
          this.searchForm.useFlag = '1'
        } else {
          this.searchForm.useFlag = ''
        }
        this.refreshList()
      },
      // 下载模板
      downloadTpl () {
        // this.$utils.downloadExcel('/sys/project/import/template')
        this.loading = true
        this.jobPositionService.exportTemplate().then((res) => {
          // 将二进制流文件写入excel表，以下为重要步骤
          this.$utils.downloadExcel(res.data, '职位导入模板')
          this.loading = false
        }).catch(function (err) {
          this.loading = false
          if (err.response) {
            console.log(err.response)
          }
        })
      },
      importMethod ({ file }) {
        // 处理表单
        const formBody = new FormData()
        formBody.append('file', file)
        this.loading = true
        this.jobPositionService.importExcel(formBody).then(result => {
          this.$message.success(result.data)
          this.refreshList()
          this.loading = false
        }).catch(() => {
          this.refreshList()
          this.loading = false
        })
      },
      // 自定义服务端导出
      exportMethod ({ options }) {
        // 传给服务端的参数
        const params = {
          'current': this.tablePage.currentPage,
          'size': this.tablePage.pageSize,
          'orders': this.tablePage.orders,
          ...this.searchForm,
          filename: options.filename,
          sheetName: options.sheetName,
          isHeader: options.isHeader,
          original: options.original,
          mode: options.mode,
          selectIds: options.mode === 'selected' ? options.data.map(item => item.id) : [],
          exportFields: options.columns.map(column => column.property)
        }
        return this.jobPositionService.exportExcel(params).then((res) => {
          // 将二进制流文件写入excel表，以下为重要步骤
          this.$utils.downloadExcel(res.data, options.filename)
        }).catch(function (err) {
          if (err.response) {
            console.log(err.response)
          }
        })
      }
    }
  }
</script>
